;******************************************************************************
;                         T I C I N P U T . A S M
;******************************************************************************
;This module checks for new A/D input data in the circular buffer "Sample_Que"
;and then processes the new data.  The analog data is processed and demodulated
;for further decoding.
;------------------------------------------------------------------------------
;                     C O N S T A N T    E Q U A T E S
;------------------------------------------------------------------------------
;
ADLIMIT         .equ    21845   ;Receive signal peak indicator limit
                                ;2^15*2.0/3 == 2.0 volt Peaks
AGC_LIMIT       .equ    1000
ONESHOT_LEN     .equ    20      ;signal peak indicator display time
                                ;20 * .005 = .1 SEC
QUAL_THRESH1    .equ    4
QUAL_THRESH2    .equ    30
SEC_NUDGE       .equ    4
;==============================================================================
;      ========          I n i t _ A i n ( )     ==========
;==============================================================================
;   if( TNC_INPUT.pin18 == +5V )
;      Flags.PTT1_LOGIC = TRUE;
;   else
;      Flags.PTT1_LOGIC = FALSE;
;   if( TNC_INPUT.pin16 == +5V )
;      Flags.PTT2_LOGIC = TRUE;
;   else
;      Flags.PTT2_LOGIC = FALSE;
;   PTT1_off();
;   PTT2_off();
;   if( R2 ){
;      Flags.RADIO_PORT = 1;
;      Sel_Input( REC_IN_2 );
;   }else{
;      Flags.RADIO_PORT = 0;
;      Sel_Input( REC_IN_1 );
;   }
;   switch( Gx )
;      case G1:
;         Sel_Gain( GAIN0 );
;         break;
;      case G1:
;         Sel_Gain( GAIN1 );
;         break;
;      case G1:
;         Sel_Gain( GAIN3 );
;         break;
;      case G1:
;         Sel_Gain( GAIN4 );
;         break;
;      case G1:
;         Sel_Gain( GAIN5 );
;         break;
;      case G1:
;         Sel_Gain( GAIN6 );
;         break;
;      default:
;         Sel_Gain( GAIN2 );
;         break;
;}
Init_Ain:                       ;initialize variables and constants
        in      Temp1,TNC_INPUT ;read PTT polarity jumper value
        lac     Temp1
        andk    RDO             ;chk PTT1
        bnz     In_K_1          ;br if port1 PTT is NEG logic
        lac     Flags           ;else is POS logic
        ork     PTT1_LOGIC
        b       In_K_2
In_K_1: lac     Flags
        andk    ~PTT1_LOGIC
        b       In_K_2
In_K_2: sacl    Flags
        lac     Temp1
        andk    XCLKO           ;chk PTT2
        bnz     In_K_3          ;br if port2 PTT is NEG logic
        lac     Flags           ;else is POS logic
        ork     PTT2_LOGIC
        b       In_K_4
In_K_3: lac     Flags
        andk    ~PTT2_LOGIC
In_K_4: sacl    Flags
;
        call    PTT1_off
        call    PTT2_off
;
#ifdef  R2
        lac     Flags
        ork     RADIO_PORT
        sacl    Flags
        lack    REC_IN_2
        sacl    Temp0
        call    Sel_Input
#else                           ;default port is PORT 1
        lac     Flags
        andk    ~RADIO_PORT
        sacl    Flags
        lack    REC_IN_1
        sacl    Temp0
        call    Sel_Input
#endif
;
        lack    GAIN1           ;default gain is GAIN1 (x2)
#ifdef  G1
        lack    GAIN0
#endif
#ifdef  G2
        lack    GAIN1
#endif
#ifdef  G4
        lack    GAIN2
#endif
#ifdef  G8
        lack    GAIN3
#endif
#ifdef  G16
        lack    GAIN4
#endif
#ifdef  G32
        lack    GAIN5
#endif
#ifdef  G64
        lack    GAIN6
#endif
        sacl    Temp0
        call    Sel_Gain
;
        lrlk    AR6,Sample_Que  ;init circular A/D & D/A buffer pointers
        lrlk    AR5,Sample_Que
        lrlk    AR4,Sample_Que+1
;
        lalk    ADLIMIT
        sacl    AD_Limit
        lalk    AGC_LIMIT
        sacl    AGC_limit
;
        lalk    4999
        sacl    Sec_timer
        zac
        sacl    AGC_Sum_h
        sacl    AGC_Sum_l
        sacl    AGC_Ave
        sacl    TIC_Sum_h
        sacl    TIC_Sum_l
        sacl    TIC_Ave
        sacl    Early_Sum_h
        sacl    Early_Sum_l
        sacl    Late_Sum_h
        sacl    Late_Sum_l
        sacl    TIC_quality
        sacl    Sec_adj
        sacl    Clk_error
        lack    60              ;   Meas_interval = 60 minutes;
        sacl    Meas_interval
;
;Load FIR Filter Coefficients into B0 Page memory
        cnfd                    ;map B0 to data memory
        larp    AR0             ;ARP = AR0 = delay line pointer
        lrlk    AR0,BP1FIRCOEF+BP1FIR_LENGTH-1
        rptk    BP1FIR_LENGTH-1 ;load Input BP1 FIR filter coefficients
        blkp    BP1FCOEF,*-     ;loads reversed order coef
        cnfp                    ;map B0 to program memory
;
        cnfd                    ;map B0 to data memory
        larp    AR0             ;ARP = AR0 = delay line pointer
        lrlk    AR0,AA1FIRCOEF+AA1FIR_LENGTH-1
        rptk    AA1FIR_LENGTH-1 ;load Input AA1 FIR filter coefficients
        blkp    AA1FCOEF,*-     ;loads reversed order coef
        cnfp                    ;map B0 to program memory
;
        cnfd                    ;map B0 to data memory
        larp    AR0             ;ARP = AR0 = delay line pointer
        lrlk    AR0,AA2FIRCOEF+AA2FIR_LENGTH-1
        rptk    AA2FIR_LENGTH-1 ;load Input AA2 FIR filter coefficients
        blkp    AA2FCOEF,*-     ;loads reversed order coef
        cnfp                    ;map B0 to program memory
;
        cnfd                    ;map B0 to data memory
        larp    AR0             ;ARP = AR0 = delay line pointer
        lrlk    AR0,LP1FIRCOEF+LP1FIR_LENGTH-1
        rptk    LP1FIR_LENGTH-1 ;load Input LP1 FIR filter coefficients
        blkp    LP1FCOEF,*-     ;loads reversed order coef
        cnfp                    ;map B0 to program memory
;
        lalk    Search_1000
        sacl    Hz1000_Vector
        ret
;..............................................................................
;==============================================================================
;        ========     S e r v i c e _ A i n ( )     ==========
;==============================================================================
;void Service_Ain()
;{
;  if( AR5 != AR6 ){            // if receive Sample_Que is not empty
;     Temp1 = Sample_Que[ AR5++ ];
;     if( abs( Temp1 ) > AD_Limit ){  //indicate clipping
;        Flags.PEAK_DET = TRUE;
;        Timer1 = ONESHOT_LEN;
;        if( !Flags.TIME_OK )
;           LED7on();
;     }
;     if( AR5 > Sample_Que + SAMPQUESIZE-1 )
;        AR5 = Sample_Que;
;     AGC_calc( Temp1 );       // perform AGC on input sample
;     ProcessInput( Temp1 );   // process new input sample
;  }
;  else{                       // here if no new sample to process
;     if( Flags.PEAK_DET ){
;        if( !Timer1 ){
;           Flags.PEAK_DET = FALSE;
;        if( !Flags.TIME_OK )
;           LED7off();
;        }
;     }
;  }
;}
;. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
Service_Ain:                    ;service input samples from A/D
        larp    AR5             ;ARP = Sample_Que tail pointer
        sar     AR6,Temp0       
        lar     AR0,Temp0       ;Temp0 = head
        cmpr    CMEQ            ;see if head == tail   TC = (AR6==AR5)
        bbnz    SA_Emty         ;br if Sample_Que is empty
        larp    AR5             ;get sample
;
        lac     *+              ;T = 16 bit A/D input value(+/- 32767)
        sacl    Temp1
;
        abs
        sub     AD_Limit
        blz     SA_1            ;br if |signal| less than the threshold limit
        lac     Flags
        ork     PEAK_DET        ;latch peak event
        sacl    Flags
        lack    ONESHOT_LEN     ;start LED7 pulse stretcher
        sacl    Timer1
        bit     Flags,T_TIME_OK
        bbnz    SA_1
        call    LED7on
SA_1:   lrlk    AR0,Sample_Que+SAMPQUESIZE-1    ;check for wrap around
        cmpr    CMGT            ;TC = (AR5>AR0)
        bbz     SA_2            ;br if no wrap
        lrlk    AR5,Sample_Que  ;else wrap it around
SA_2:
        call    AGC_calc        ;Do the AGC on Temp1 sample
        call    ProcessInput    ;go process next A/D input sample in Temp1
        ret
SA_Emty:
        bit     Flags,T_PEAK_DET
        bbz     SA_exit         ;if peak det LED is on then
        lac     Timer1          ;check timeout
        bnz     SA_exit
        lac     Flags
        andk    ~PEAK_DET
        sacl    Flags
        bit     Flags,T_TIME_OK
        bbnz    SA_exit
        call    LED7off
SA_exit:
        ret
;
;==============================================================================
;             =======   A G C _ c a l c ( Temp1 )     =======
;==============================================================================
;This routine is called every A/D sample and calculates a new AGC gain value.
;
;void AGC_calc(Temp1)
;   DeltaNew = OldInput - NewInput;
;   if( ( DeltaNew ^ DeltaOld ) & BIT15 ){      // if sign changed
;      OldInput = abs( OldInput );      // OldInput is peak signal
;      AGC_Sum = AGC_Sum + OldInput - AGC_Ave;
;      AGC_Ave = AGC_Ave/8;
;   }
;   DeltaOld = DeltaNew;
;   OldInput = Temp1;
;   if( !Flags.TIME_OK )
;      if( AGC_Ave >= AGC_limit )
;         LED7on();
;      else
;         LED7off();
;   Temp1 = Temp1/AGC_Ave;              // scale sample by AGC gain
;}
AGC_calc:
        lac     OldInput
        sub     Temp1
        sacl    DeltaNew        ;DeltaNew = OldInput - NewInput
        xor     DeltaOld        ;see if derivative sign changed
        sacl    Temp0
        bit     Temp0,15        ;see if sign bit has changed
        bbz     Ac_1            ;br if not at signal peak
        lac     OldInput
        abs
        sacl    OldInput
;
        zals    AGC_Sum_l
        addh    AGC_Sum_h
        sub     AGC_Ave         ;sub old average
        add     OldInput        ;add another sample
        sach    AGC_Sum_h
        sacl    AGC_Sum_l
        sach    AGC_Ave,4       ;running average over 2^(16-4)=4096 samples
;$$$$$$$$$$$$$$$$
;        lac     AGC_Ave
;        andk    0FFFCh
;        sacl    TestOut         ;TEST OUT
;$$$$$$$$$$$$$$$$
Ac_1:
        lac     DeltaNew        ;update AGC delay lines
        sacl    DeltaOld
        lac     Temp1
        sacl    OldInput
;
        bit     Flags,T_TIME_OK
        bbnz    Ac_3
        lac     AGC_Ave         ; see if enough signal to AGC
        sub     AGC_limit
        bgez    Ac_2
        call    LED6off         ;Signal too weak to AGC
        b       Ac_3
Ac_2:   call    LED6on          ;Signal enough to AGC
Ac_3:   lac     AGC_Ave
        adlk    0200h
        sacl    Temp0           ;Temp0 = AGC_Ave + (1/128)
        lalk    0400h,15        
        rptk    14
        subc    Temp0
        sacl    Temp0           ;temp0 = (1/256)/Temp0;
;
        lt      Temp1           ;T = 16 bit input value(+/- 32767)
        mpy     Temp0
        pac
        sach    Temp1,3         ;multiply input by AGCgain value
;$$$$$$$$$$$$$$$$
;        lac     Temp1
;        andk    0FFFCh
;        sacl    TestOut         ;TEST OUT
;$$$$$$$$$$$$$$$$
        ret
;
;==============================================================================
;      =======   P r o c e s s I n p u t ( input )     =======
;==============================================================================
;
;void ProcessInput( Temp1 )
;{
;   AA1Fdelay[ 0 ] = Temp1;     // do Anti aliasing LP filter
;   acc = 0;                    // do at 5KHz rate
;   for( i=AA1FIR_LENGTH-1; i >= 0; i-- ){
;      acc += AA1Fdelay[ i ] * AA1FIRCOEF[ i ];
;      AA1delay[ i+1 ] = AA1delay[ i ];
;   }
;   Temp1 = acc;
;   if( --Deci_count1 & 0x01 ){ // do at 5KHz rate
;      BP1Fdelay[ 0 ] = Temp1;
;      acc = 0;
;      for( i=BP1FIR_LENGTH-1; i >= 0; i-- ){
;         acc += BP1Fdelay[ i ] * BP1FIRCOEF[ i ];
;      }
;      Temp1 = abs(acc);        // Temp1 = 1000Hz Bandpass output
;      acc = 0;
;      for( i=AA2FIR_LENGTH-1; i >= 0; i-- ){
;         acc += BP1Fdelay[ i ] * AA2FIRCOEF[ i ];
;         BP1delay[ i+1 ] = BP1delay[ i ];
;      }
;      Decout_1 = acc;          // Decout_1 = 500Hz Anti alias LP output
;      LP1Fdelay[ 0 ] = Temp1;
;      acc = 0;
;      for( i=LP1FIR_LENGTH-1; i >= 0; i-- ){
;         acc += LP1Fdelay[ i ] * LP1FIRCOEF[ i ];
;         LP1delay[ i+1 ] = LP1delay[ i ];
;      }
;      PK1_Ave = acc;           // PK1_Ave = 200Hz LP filtered output
;   }
;   else{                       // do at 5KHz rate when not doing above filter
;      if( --Deci_mod5 == 0 ){  // do every 5 times or 1000Hz
;         Deci_mod5 = 5;
;         AA2Fdelay[ 0 ] = Decout1;   // do Anti aliasing LP filter
;         acc = 0;                    // do at 1KHz rate
;         for( i=AA1FIR_LENGTH-1; i >= 0; i-- ){
;            acc += AA2Fdelay[ i ] * AA1FIRCOEF[ i ];
;            AA2delay[ i+1 ] = AA2delay[ i ];
;         }
;         Temp1 = acc;
;         if( --Deci_count2 & 0x01 ){ // do at 500Hz rate
;            BP2Fdelay[ 0 ] = Temp1;
;            acc = 0;
;            for( i=BP1FIR_LENGTH-1; i >= 0; i-- ){
;               acc += BP2Fdelay[ i ] * BP1FIRCOEF[ i ];
;               BP2delay[ i+1 ] = BP2delay[ i ];
;            }
;            Temp1 = abs(acc);          // Temp1 = 100Hz Bandpass output
;            LP2Fdelay[ 0 ] = Temp1;
;            acc = 0;
;            for( i=LP2FIR_LENGTH-1; i >= 0; i-- ){
;               acc += LP2Fdelay[ i ] * LP1FIRCOEF[ i ];
;               LP2delay[ i+1 ] = LP2delay[ i ];
;            }
;            PK2_Ave = acc;             // PK2_Ave = 20Hz LP filtered output
;         }
;      }
;      TIC_Sum = TIC_Sum + Level_1000 - TIC_Ave;
;      TIC_Ave = TIC_Sum/512;
;      if( --Sec_timer == 0 ){
;         Sec_timer = 5000 + Sec_adj;
;         Sec_adj = 0;
;      }
;      ProcessTIC();                    // Process 1000Hz tic signal
;   }
;}
;..........................................................................
ProcessInput:
; . . . . . .   Calculate Lowpass Antialias FIR filter   . . . . . . . . .
;Runs at 10000 Hz
        larp    AR0             ;ARP = AR0 = delay line pointer
        lrlk    AR0,AA1Fdelay   ;AR0 points to start of delay line
        lac     Temp1
        sacl    *               ;store new sample at beginning of buf
        adrk    AA1FIR_LENGTH-1 ;point to end of delay line
        mpyk    0		;initialize sum and product registers
        zac
        rptk    AA1FIR_LENGTH-1 ;multiply and accumulate
        macd    (AA1FIRCOEF+B0PADDR-B0DADDR),*-
        apac                    ; include last product
        sach    Temp1           ;filter gain = 1
;
        INC(Deci_count1)        ;increment decimation counter
        bit     Deci_count1,0
        bbz     PI_4
;Runs at 5000 Hz
;
; . . . . . .   Calculate 1000 Hz Bandpass FIR filter   . . . . . . . . .
        lrlk    AR0,BP1Fdelay    ;AR0 points to start of delay line
        lac     Temp1
        sacl    *               ;store new sample at beginning of buf
        lrlk    AR0,BP1Fdelay   ;AR0 points to start of delay line
        adrk    BP1FIR_LENGTH-1 ;point to end of delay line
        mpyk    0		;initialize sum and product registers
        zac
        rptk    BP1FIR_LENGTH-1 ;multiply and accumulate
        mac     (BP1FIRCOEF+B0PADDR-B0DADDR),*-
        apac                    ; include last product
        abs
        sach    Temp1           ;filter gain = 1
;
; . . . . . .   Calculate 500 Hz Lowpass Antialias FIR filter   . . . . . . . . .
;        lrlk    AR0,BP1Fdelay   ;AR0 points to start of delay line
        adrk    AA2FIR_LENGTH-1 ;point to end of delay line
        mpyk    0		;initialize sum and product registers
        zac
        rptk    AA2FIR_LENGTH-1 ;multiply and accumulate
        macd    (AA2FIRCOEF+B0PADDR-B0DADDR),*-
        apac                    ; include last product
        sach    Decout_1        ;filter gain = 1
;
;$$$$$$$$$$$$$$$$
;        lac     Decout_1
;        lac     Temp1
;        andk    0FFFCh
;        sacl    TestOut         ;TEST OUT
;$$$$$$$$$$$$$$$$
; . . . . . .   Calculate Lowpass Peak detector FIR filter   . . . . . . . 
;Runs at 5000 Hz
        lrlk    AR0,LP1Fdelay   ;AR0 points to start of delay line
        lac     Temp1
        sacl    *               ;store new sample at beginning of buf
        adrk    LP1FIR_LENGTH-1 ;point to end of delay line
        mpyk    0		;initialize sum and product registers
        zac
        rptk    LP1FIR_LENGTH-1  ;multiply and accumulate
        macd    (LP1FIRCOEF+B0PADDR-B0DADDR),*-
        apac                    ; include last product
        sach    Level_1000
;$$$$$$$$$$$$$$$$
        lac     Level_1000
        andk    0FFFCh
        sacl    TestOut         ;TEST OUT
;$$$$$$$$$$$$$$$$
        b       PI_6
;
PI_4:
;Runs at 5000 Hz
        DEC(Deci_mod5)
        bnz     PI_5
        lack    5
        sacl    Deci_mod5
; . . . . . .   Calculate Lowpass Antialias FIR filter   . . . . . . . . .
;Runs at 1000 Hz
        lrlk    AR0,AA2Fdelay   ;AR0 points to start of delay line
        lac     Decout_1
        sacl    *               ;store new sample at beginning of buf
        adrk    AA1FIR_LENGTH-1  ;point to end of delay line
        mpyk    0		;initialize sum and product registers
        zac
        rptk    AA1FIR_LENGTH-1  ;multiply and accumulate
        macd    (AA1FIRCOEF+B0PADDR-B0DADDR),*-
        apac                    ; include last product
        sach    Temp1           ;filter gain = 1
;
;$$$$$$$$$$$$$$$$
;        lac     Temp1
;        andk    0FFFCh
;        sacl    TestOut         ;TEST OUT
;$$$$$$$$$$$$$$$$

        INC(Deci_count2)        ;increment decimation counter
        bit     Deci_count2,0
        bbz     PI_5
; . . . . . .   Calculate 100 Hz Bandpass FIR filter   . . . . . . . . .
        lrlk    AR0,BP2Fdelay    ;AR0 points to start of delay line
        lac     Temp1
        sacl    *               ;store new sample at beginning of buf
        adrk    BP1FIR_LENGTH-1 ;point to end of delay line
        mpyk    0		;initialize sum and product registers
        zac
        rptk    BP1FIR_LENGTH-1 ;multiply and accumulate
        macd    (BP1FIRCOEF+B0PADDR-B0DADDR),*-
        apac                    ; include last product
        abs
        sach    Temp1,1         ;filter gain = 2
;
; . . . . . .   Calculate Lowpass Peak detector FIR filter   . . . . . . . 
;Runs at 500 Hz
        lrlk    AR0,LP2Fdelay   ;AR0 points to start of delay line
        lac     Temp1
        sacl    *               ;store new sample at beginning of buf
        adrk    LP1FIR_LENGTH-1 ;point to end of delay line
        mpyk    0		;initialize sum and product registers
        zac
        rptk    LP1FIR_LENGTH-1  ;multiply and accumulate
        macd    (LP1FIRCOEF+B0PADDR-B0DADDR),*-
        apac                    ; include last product
        sach    Level_100
;$$$$$$$$$$$$$$$$
;        lac     Level_100
;        lac     Temp1
;        andk    0FFFCh
;        sacl    TestOut         ;TEST OUT
;$$$$$$$$$$$$$$$$
PI_5:
        zals    TIC_Sum_l
        addh    TIC_Sum_h
        sub     TIC_Ave         ;sub old average
        add     Level_1000      ;add another sample
        sach    TIC_Sum_h
        sacl    TIC_Sum_l
        sach    TIC_Ave,7       ;running average over 2^(16-7)=512 samples
;
        lac     Sec_timer
        subk    1
        sacl    Sec_timer
        bnz     PI_7
        lalk    5000
        add     Sec_adj
        sacl    Sec_timer
        zac
        sacl    Sec_adj
PI_7:
;
        lac     Hz1000_Vector   ;call state vector for processing 1000Hz tic
        cala
PI_6:
        ret
;==============================================================================
;                 =======   Search_1000 ( )     =======
;==============================================================================
;  This state processes the tic signal when the seconds position is not known
;such as in initialization or after a long period of no signal.  Runs at 5KHz.
;
;Search_1000(){
;   if( TIC_Mask_timer == 0 ){
;      if( Level_1000 > TIC_Ave*4 ){
;         TIC_Mask_timer = 198;
;         if( Sec_timer >= 2470 && Sec_timer <= 2570 ){
;            TIC_quality++;
;         }else{
;            TIC_quality = 0;
;         }
;         Sec_timer = 2570;
;         if( TIC_quality >= QUAL_THRESH1 ){
;            TIC_quality = QUAL_THRESH2;
;            Hz1000_Vector = Lock_1000;
;         }
;      }
;   }
;}
;------------------------------------------------------------------------------
Search_1000:
        lac     TIC_Mask_timer  ;see if masked out until next second time
        bnz     S1_exit
        lac     Level_1000      ;see if above threshold
        sub     TIC_Ave,2
        blez    S1_exit         ;br if not
;
        lack    198             ;start Mask interval
        sacl    TIC_Mask_timer
;
        lalk    2570
        sub     Sec_timer
        blz     S1_2            ;br if Sec_timer > 2570
        lalk    2470
        sub     Sec_timer
        bgz     S1_2            ;br if Sec_timer < 2470
        INC(TIC_quality)
        b       S1_3
S1_2:   zac
        sacl    TIC_quality
;
S1_3:
        lalk    2520
        sacl    Sec_timer
        lack    QUAL_THRESH1
        sub     TIC_quality
        bgz     S1_exit
        lack    QUAL_THRESH2
        sacl    TIC_quality
        lalk    Lock_1000
        sacl    Hz1000_Vector
S1_exit:
        ret

;==============================================================================
;                   =======   Lock_1000 ( )     =======
;==============================================================================
;  This state processes the tic signal when the seconds position is known
;and continues tweaking the phase of the seconds timer to maintain lock with
;the tic signal.
;
;Lock_1000(){
;    if( Sec_timer <= 2564 ){
;      if( Sec_timer >= 2499 ){
;         Early_Sum += Level_1000;      // between 2499 and 2564
;      }else{
;         if( Sec_timer >= 2435 ){
;            Late_Sum += Level_1000;    // between 2435 and 2500
;         }
;      }
;    }else{                             // between 4999 and 2565
;      if( Sec_timer == 2566 ){
;         if( Sec_pos != 0 ){           // skip long minute tic marker
;            if( (Early_Sum+Late_Sum)/256 > TIC_Ave ){
;               if( Early_Sum >= 2*Late_Sum ){      // if Sec_timer is late
;                  Sec_adj = SEC_NUDGE;
;                  Clk_error++;
;               }else{
;                  if( Late_Sum >= 2*Early_Sum ){   // if Sec_timer is early
;                     Sec_adj = -SEC_NUDGE;
;                     Clk_error--;
;                  }else{                           // if on time
;                     TIC_quality += 10;
;                     if( TIC_quality > QUALITY_THRESH2 ){
;                        TIC_quality = QUALITY_THRESH2;
;                        Flags.POSLOCKED = TRUE;
;                        Sec_pos = 181 + 66*(200/5000);
;                     }
;                  }
;               }
;            }else{
;               if( TIC_quality > 0 ){
;                  TIC_quality--;
;               }else{
;                  TIC_quality = 0;
;                  Flags.POSLOCKED = FALSE;
;                  Hz1000_Vector = Search_1000;
;               }
;            }
;         }
;         Early_Sum = 0;                        // reset integrators
;         Late_Sum = 0;
;      }
;   }
;}
;------------------------------------------------------------------------------
Lock_1000:
        lalk    2564
        sub     Sec_timer
        blz     L1_2            ;br if( Sec_timer > 2564 )
        lalk    2499
        sub     Sec_timer
        bgez    L1_3            ;br if( Sec_timer <= 2499 )
        zals    Early_Sum_l     ;integrate early sum over 64 samples
        addh    Early_Sum_h     ;from 2564 down to 2500
        add     Level_1000      
        sach    Early_Sum_h
        sacl    Early_Sum_l
        b       L1_exit
L1_3:                           ;here if Sec_timer < 2499
        lalk    2435
        sub     Sec_timer
        bgz     L1_exit         ;br if( Sec_timer < 2435 )
        zals    Late_Sum_l      ;integrate Late sum over 64 samples
        addh    Late_Sum_h      ;from 2499 down to 2435
        add     Level_1000      
        sach    Late_Sum_h
        sacl    Late_Sum_l
        b       L1_exit
L1_2:
        lalk    2566
        sub     Sec_timer
        bnz     L1_exit          ;br if( Sec_timer != 2566 )
;
        lac     Sec_count
        subk    1
        bz      L1_6

        zals    Early_Sum_l
        addh    Early_Sum_h
        adds    Late_Sum_l
        addh    Late_Sum_h
        sfl
        sach    Temp0,7         ;Temp0 = (Early_Sum+Late_Sum)/256
        lac     Temp0
        sub     TIC_Ave         ;acc = (Early_Sum+Late_Sum)/256 - TIC_Ave
        blez    L1_5            ;br if( (Early_Sum+Late_Sum)/256 <= TIC_Ave )
;
        zals    Early_Sum_l
        addh    Early_Sum_h
        sfl
        subs    Late_Sum_l
        subh    Late_Sum_h      ;acc = 2*Early_Sum - Late_Sum
        bgez    L1_4            ;br if( 2*Early_Sum <= Late_Sum )
        lack    SEC_NUDGE
        sacl    Sec_adj
        INC(Clk_error)
        b       L1_5
L1_4:
        zals    Late_Sum_l
        addh    Late_Sum_h
        sfl
        subs    Early_Sum_l
        subh    Early_Sum_h     ;acc = 2*Late_Sum - Early_Sum
        bgez    L1_7            ;br if( 2*Late_Sum <= Early_Sum )
        lalk    -SEC_NUDGE
        sacl    Sec_adj
        DEC(Clk_error)
        b       L1_5
L1_7:
        lac     TIC_quality
        addk    10
        sacl    TIC_quality
        subk    QUAL_THRESH2
        blz     L1_6
        lalk    QUAL_THRESH2
        sacl    TIC_quality
        lack    181+3
        sacl    Sec_pos
        lac     Flags
        ork     POS_LOCKED
        sacl    Flags           ; Flags.POS_LOCKED = TRUE;
        b       L1_6
L1_5:                           ;here if not enough tic signal
        lac     TIC_quality     ;if( TIC_quality > 0 ){
        blez    L1_8            ;   TIC_quality--;
        subk    1
        sacl    TIC_quality
        b       L1_6
L1_8:
        zac
        sacl    TIC_quality
        lalk    Search_1000     ;dispatch search routine again
        sacl    Hz1000_Vector
        lac     Flags
        andk    ~POS_LOCKED
        sacl    Flags           ; Flags.POS_LOCKED =FALSE;
L1_6:
        zac                     ;reset integrators
        sacl    Early_Sum_h
        sacl    Early_Sum_l
        sacl    Late_Sum_h
        sacl    Late_Sum_l
L1_exit:
        ret

;==============================================================================
;      ========== E N D   o f   T I C T I M E . A S M =============
;==============================================================================
