;******************************************************************************
;                      T I C S O U N D . A S M
;******************************************************************************
;  A new D/A output sample is calculated and placed in the circular buffer
; "Sample_Que".  Various sounds are initiated depending on time values.
;==============================================================================
;==============================================================================
;      ========          I n i t _ A o u t ( )     ==========
;==============================================================================
Init_Aout:                      ;initialize variables
        lalk    Sound_hr_state
        sacl    Sound_Vector
        lack    1
        sacl    Local_hr
        ret
;..............................................................................
;==============================================================================
;       =========      S e r v i c e _ S o u n d ( )    =========
;==============================================================================
;Put samples into the D/A converter circular buffer for transmitting.
;void Service_Sound()
;{
;  if( AR4 != AR5 ){            // if transmit Sample_Que is not full
;     Sample_Que[ AR4++ ] = OutBuf;
;     if( AR4 > Sample_Que + SAMPQUESIZE-1 )
;        AR4 = Sample_Que;
;     }
;     Service_sound();          // Create next D/A sound sample
;                               // at 10KHz rate
;     if( Sec_count != Prev_sec )
;        Prev_sec = Sec_count;
;        Sound_Vector();        // Call Sound state machine every second
;  }
;}
;. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
Service_Sound:                  ;service sending of output samples to D/A
        larp    AR4             ;ARP = Sample_Que xmit head pointer
        sar     AR5,Temp0       ;
        lar     AR0,Temp0       ;Temp0 = receive tail
        cmpr                    ;see if head == tail
        bbnz    SAo_6           ;br to exit if Sample_Que is full
        lac     OutBuf
        andk    0FFFCh
        sacl    *+              ;put next output data in Sample_Que and
                                ;inc head pointer
        lrlk    AR0,Sample_Que+SAMPQUESIZE-1    ;check for wrap around
        cmpr    CMGT            ;TC= (AR4>AR0)
        bbz     SAo_1           ;br if no wrap
        lrlk    AR4,Sample_Que  ;else wrap it around
SAo_1:
        call    Service_sound
        lac     Sec_count       ;if( Sec_count != Prev_sec )
        sub     Prev_sec        
        bz      SAo_6
        lac     Sec_pos         ;   if( Sec_pos == 185 )
        subk    185
        bnz     SAo_6
        lac     Sec_count       ;      Prev_sec = Sec_count;
        sacl    Prev_sec
        lac     Sound_Vector    ;call state vector for starting sounds
        cala                    ;   Sound_Vector();
SAo_6:  ret

;==============================================================================
;       =========     S o u n d _ i d l e _ s t a t e  ( )    =========
;==============================================================================
;   State when no sound is active.  Dispatches various sounds depending on the
;present time values.
;void Sound_idle_state()
;{
;   if( Flags.TIME_OK ){
;      if( Hr_count != Prev_hr ){
;         Prev_hr = Hr_count;
;         Sound_Vector = Sound_hr_state;
;      }else{
;         if( Min_count != Prev_min ){
;            Prev_min = Min_count;
;            switch( Min_count ){
;               case 15:
;                  Sound_Vector = Sound_15_state;
;                  break;
;               case 30:
;                  Sound_Vector = Sound_30_state;
;                  break;
;               case 45:
;                  Sound_Vector = Sound_45_state;
;                  break
;               default:
;                  break;
;            }
;         }
;      }
;   }
;   if( (Sec_count & BIT0 ){             // tick or tock every
;      Sound_Vector = Sound_tick_state; // second
;   else
;      Sound_Vector = Sound_tock_state;
;   }
;}
Sound_idle_state:
        bit     Flags,T_TIME_OK
        bbz     Sis_2
        lac     Hr_count
        sub     Prev_hr
        bz      Sis_1
        lac     Hr_count        ; if( Hr_count != Prev_hr && Flags.TIME_OK )
        sacl    Prev_hr
        lalk    Sound_hr_state
        sacl    Sound_Vector
        b       Sis_exit
Sis_1:
        lac     Min_count
        sub     Prev_min
        bz      Sis_2
        lac     Min_count       ;if( Min_count != Prev_min && Flags.MIN_LOCKED ){
        sacl    Prev_min        ;   Prev_min = Min_count;
        lac     Min_count
        subk    15
        bnz     Sis_3
        lalk    Sound_15_state
        sacl    Sound_Vector
        b       Sis_2
Sis_3:
        lac     Min_count
        subk    30
        bnz     Sis_4
        lalk    Sound_30_state
        sacl    Sound_Vector
        b       Sis_2
Sis_4:
        lac     Min_count
        subk    45
        bnz     Sis_2
        lalk    Sound_45_state
        sacl    Sound_Vector
Sis_2:
        bit     Sec_count,0
        bbz     Sis_5
        lalk    TICK
        sacl    Sound_ptr
        call    Start_Sound
        b       Sis_exit
Sis_5:
        lalk    TOCK
        sacl    Sound_ptr
        call    Start_Sound
Sis_exit:
        ret

;==============================================================================
;       =========     S o u n d _ 1 5 _ s t a t e  ( )    =========
;==============================================================================
;   State to start sound at 15 minute mark.
;void Sound_15_state()
;{
;   Start_Sound( SOUND15 );
;   Sound_Vector = Sound_idle_state;
;}
Sound_15_state:
        lalk    SOUND15
        sacl    Sound_ptr
        call    Start_Sound
        lalk    Pause_state
        sacl    Sound_Vector
        ret

;==============================================================================
;       =========     S o u n d _ 3 0 _ s t a t e  ( )    =========
;==============================================================================
;   State to start sound at 30 minute mark.
;void Sound_30_state()
;{
;   Start_Sound( SOUND30 );
;   Sound_Vector = Sound_idle_state;
;}
Sound_30_state:
        lalk    SOUND30
        sacl    Sound_ptr
        call    Start_Sound
        lalk    Pause_state
        sacl    Sound_Vector
        ret

;==============================================================================
;       =========     S o u n d _ 4 5 _ s t a t e  ( )    =========
;==============================================================================
;   State to start sound at 45 minute mark.
;void Sound_45_state()
;{
;   Start_Sound( SOUND45 );
;   Sound_Vector = Sound_idle_state;
;}
Sound_45_state:
        lalk    SOUND45
        sacl    Sound_ptr
        call    Start_Sound
        lalk    Pause_state
        sacl    Sound_Vector
        ret

;==============================================================================
;       =========     P a u s e _ s t a t e  ( )    =========
;==============================================================================
;   State to skip one second and let the bells fade out.
;void Pause_state()
;{
;   Sound_Vector = Sound_idle_state;
;}
Pause_state:
        lalk    Sound_idle_state
        sacl    Sound_Vector
        ret

;==============================================================================
;       =========     S o u n d _ h r _ s t a t e  ( )    =========
;==============================================================================
;   State to start sound sequence at hour mark.
;void Sound_hr_state()
;{
;   Gong_count = Local_hr;
;   Start_Sound( HOURSOUND1 );
;   Sound_Vector = Sound_hrbeg1_state;
;}
Sound_hr_state:
        lac     Local_hr
        sacl    Gong_count
        lalk    HOURSOUND1
        sacl    Sound_ptr
        call    Start_Sound
        lalk    Sound_hrbeg1_state
        sacl    Sound_Vector
        ret
;==============================================================================
;      =========     S o u n d _ h r b e g 1 _s t a t e  ( )    =========
;==============================================================================
;   State to sound common sounds at hour mark.
;void Sound_hrbeg1_state()
;{
;   Start_Sound( HOURSOUND2 );
;   Sound_Vector = Sound_hr_beg2_state;
;}
Sound_hrbeg1_state:
        lalk    HOURSOUND2
        sacl    Sound_ptr
        call    Start_Sound
        lalk    Sound_hrbeg2_state
        sacl    Sound_Vector
        ret

;==============================================================================
;      =========     S o u n d _ h r b e g 2 _s t a t e  ( )    =========
;==============================================================================
;   State to sound common sounds at hour mark.
;void Sound_hrbeg2_state()
;{
;   Start_Sound( HOURSOUND3 );
;   Sound_Vector = Sound_hr_gongs_state;
;}
Sound_hrbeg2_state:
        lalk    HOURSOUND3
        sacl    Sound_ptr
        call    Start_Sound
        lalk    Sound_hrbeg3_state
        sacl    Sound_Vector
        ret

;==============================================================================
;      =========     S o u n d _ h r b e g 3 _s t a t e  ( )    =========
;==============================================================================
;   State to sound common sounds at hour mark.
;void Sound_hrbeg3_state()
;{
;   Sound_Vector = Sound_hr_gongs_state;
;}
Sound_hrbeg3_state:
        lalk    Sound_hrgongs_state
        sacl    Sound_Vector
        ret

;==============================================================================
;      =========     S o u n d _ h r g o n g s _s t a t e  ( )    =========
;==============================================================================
;   State to sound N sounds at Nth hour mark.
;void Sound_hrgongs_state()
;{
;   if( --Gong_count >= 0 ){
;      Start_Sound( GONGS );
;   }else{
;      Sound_Vector = Sound_idle_state;
;   }
;}
Sound_hrgongs_state:
        lac     Gong_count
        subk    1
        sacl    Gong_count
        blz     S_hrg1
        lalk    GONGS
        sacl    Sound_ptr
        call    Start_Sound
        b       S_hrg2
S_hrg1:
        lalk    Sound_idle_state
        sacl    Sound_Vector
S_hrg2:
        ret

;==============================================================================
;       =========     S e r v i c e _ s o u n d  ( )    =========
;==============================================================================
;   Routine to calculate the next D/A OutBuf value if a sound is active.
;void Service_sound(){
;   if( Flags.SOUND_ACTIVE ){
;      Sound_position++;
;      Temp0 = tbl_pos;
;      if( *Temp0 != 0 ){
;         if( Sound_position >= *Temp0 ){
;            ACC = Temp0;
;            ACC++;
;            AR1 = FMgen1 + 2;
;            *AR1 = *(ACC++);
;            AR1 += 4;
;            *AR1 = *(ACC++);
;            AR1 = FMgen2 + 2;
;            *AR1 = *(ACC++);
;            AR1 += 4;
;            *AR1 = *(ACC++);
;            AR1 = FMgen3 + 2;
;            *AR1 = *(ACC++);
;            AR1 += 4;
;            *AR1 = *(ACC++);
;            tbl_pos = ACC;
;         }
;         AR0 = FMgen1;
;         Calc_sample();
;         OutBuf = Temp1;
;         Calc_sample();
;         OutBuf += Temp1;
;         Calc_sample();
;         OutBuf += Temp1;
;      }else{
;         Flags.SOUND_ACTIVE = FALSE;
;      }
;   }
;}
Service_sound:
        bit     Flags,T_SOUND_ACTIVE    ;if( Flags.SOUND_ACTIVE )
        bbz     Se_S1
        INC(Sound_position)
        lac     tbl_pos
        sacl    Temp0
        tblr    Temp1                   ;Temp1 = *ACC
        lac     Temp1
        bz      Se_S2
        sub     Sound_position          ;if( Sound_position >= *Temp0 )
        bgz     Se_S3
        larp    AR1                     ;ARP = AR1
        lac     Temp0                   ;  ACC = Temp0;
        addk    1                       ;  ACC++;
        lrlk    AR1,FMgen1+2            ;  AR1 = FMgen1 + 2;
        tblr    *                       ;  *AR1 = *(ACC++);
        addk    1
        adrk    4                       ;  AR1 += 4;
        tblr    *                       ;  *AR1 = *(ACC++);
        addk    1
;            
        lrlk    AR1,FMgen2+2            ;  AR1 = FMgen2 + 2;
        tblr    *                       ;  *AR1 = *(ACC++);
        addk    1
        adrk    4                       ;  AR1 += 4;
        tblr    *                       ;  *AR1 = *(ACC++);
        addk    1
;            
        lrlk    AR1,FMgen3+2            ;  AR1 = FMgen3 + 2;
        tblr    *                       ;  *AR1 = *(ACC++);
        addk    1
        adrk    4                       ;  AR1 += 4;
        tblr    *                       ;  *AR1 = *(ACC++);
        addk    1
        sacl    tbl_pos                 ;  tbl_pos = ACC;
Se_S3:
        larp    AR0                     ;ARP = AR0
        lrlk    AR0,FMgen1              ;AR0 = FMgen1;
        call    Calc_sample
        lac     Temp1
        sacl    OutBuf                  ;OutBuf = Temp1;
        lrlk    AR0,FMgen2              ;AR0 = FMgen2;
        call    Calc_sample
        lac     Temp1
        add     OutBuf
        sacl    OutBuf                  ;OutBuf += Temp1;
        lrlk    AR0,FMgen3              ;AR0 = FMgen3;
        call    Calc_sample
        lac     Temp1
        add     OutBuf
        sacl    OutBuf                  ;OutBuf += Temp1;
        b       Se_S1
Se_S2:  lac     Flags
        andk    ~SOUND_ACTIVE
        sacl    Flags           ; Flags.SOUND_ACTIVE = FALSE;
        zac
        sacl    OutBuf                  ;OutBuf += Temp1;
Se_S1:  
        ret
;. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
;==============================================================================
;       =========      S t a r t _ S o u n d  ( )    =========
;==============================================================================
;   Routine starts a new sound where ACC points to the beginning of the
;desired sound table.
;void Start_Sound( ACC ){
;   AR1 = FMgen1;
;   AR2 = 24-1;
;   do{
;      *(AR1++) = *(ACC++);
;   }while(  AR2-- != 0 );
;   tbl_pos = ACC;              // FMgen1+24
;   OutBuf = 0;
;   Sound_position = 0;
;   Flags.SOUND_ACTIVE = TRUE;
;}
Start_Sound:
        larp    AR1             ;ARP = AR1
        lrlk    AR1,FMgen1
        lrlk    AR2,24-1        ;AR2 = loop counter
St_S1:  tblr    *+,AR2
        addk    1
        banz    St_S1,*-,AR1
        sacl    tbl_pos
        zac
        sacl    OutBuf
        sacl    Sound_position
        lac     Flags
        ork     SOUND_ACTIVE
        sacl    Flags           ; Flags.SOUND_ACTIVE = TRUE;
        ret
;. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
;==============================================================================
;       =========      C a l c _ s a m p l e  ( )    =========
;==============================================================================
;   Routine calculates a new sample of a single FM generator pointed to
;by AR0.  The new sample value is returned in Temp1.
;
; AR0 = ptr to frequency generator data structure as follows:
;  AR0[0] --->  modulation phz increment value
;  AR0[1] --->  modulation phz accumulator
;  AR0[2] --->  modulation index slope value
;  AR0[3] --->  modulation index
;  AR0[4] --->  carrier phz increment value
;  AR0[5] --->  carrier phz accumulator
;  AR0[6] --->  carrier amplitude slope value
;  AR0[7] --->  carrier amplitude
;
;int Calc_sample( AR0 ){
;    Temp1 = ( AR0[7]+=AR0[6] ) * SIN( (AR0[5]+=AR0[4]) +
;                          ( AR0[3]+=AR0[2] ) * SIN( (AR0[1]+=AR0[0] ) );
; }
Calc_sample:
        larp    AR0
        lac     *+              ;get modulation phz inc value AR0[0]
        add     *               ;add modulation phz acc       AR0[1]
        sacl    *               ;save new phz acc value       AR0[1]
        rsxm
        lac     *+,8            ;get modulator phase accumulator value
        sach    Temp0           ;SIN table_ptr=top 8 msbits
        lac     Temp0
        adlk    SIN_TABLE       ;get sin lookup value
        tblr    Temp0
        ssxm
        lt      Temp0
        lac     *+              ;get current modulation index slope AR0[2]
        add     *               ;add to modulation index            AR0[3]
        sacl    *               ;save new modulation index          AR0[3]
        mpy     *+              ;mpy modulation sin value by mod amplitude
        pac
        sach    Temp1
;
        lac     *+              ;get carrier phz inc value     AR0[4]
        add     *               ;add carrier phz acc           AR0[5]
        sacl    *+              ;store new carrier phz acc     AR0[5]
        add     Temp1           ;add Modulation sin value to
        sacl    Temp1
        rsxm
        lac     Temp1,8         ;get current sin phase accumulator value
        sach    Temp0           ;SIN table_ptr=top 8 msbits
        lac     Temp0
        adlk    SIN_TABLE       ;get sin lookup value
        tblr    Temp0
        ssxm
        lac     Temp0
        sfr
        sfr
        sacl    Temp0
        lt      Temp0
        lac     *+              ;get carrier amplitude slope    AR0[6]
        add     *               ;add to present amplitude value AR0[7]
        sacl    *               ;save new amplitude             AR0[7]
        mpy     *+              ;mpy carrier sin value by amplitude value
        pac
        sach    Temp1
        ret

;==============================================================================
;       ========== E N D   o f   T I C S O U N D . A S M ============
;==============================================================================
