;******************************************************************************
;                      T I C U A R T . A S M
;******************************************************************************
;
;==============================================================================
;     ========          I n i t _ T I C u a r t ( )     ==========
;==============================================================================
Init_TICuart:                   ;initialize variables
        lalk    -5              ;default local offset to EST
#ifdef  EST
        lalk    -5
#endif
#ifdef  CST
        lalk    -6
#endif
#ifdef  MST
        lalk    -7
#endif
#ifdef  PST
        lalk    -8
#endif
#ifdef  GMT
        lalk    0
#endif
        sacl    Local_offset
;
        larp    AR0
        lrlk    AR0,ASCII_Status
        lack    '0'
        sacl    *+              ;0
        sacl    *+              ;1
        lack    ','
        sacl    *+              ;2
        lack    '0'
        sacl    *+              ;3
        sacl    *+              ;4
        lack    ','
        sacl    *+              ;5
        lack    '0'
        sacl    *+              ;6
        sacl    *+              ;7
        lack    ','
        sacl    *+              ;8
        lack    '0'
        sacl    *+              ;9
        sacl    *+              ;10
        lack    CR
        sacl    *+              ;11   CR
        lack    LF
        sacl    *               ;12   LF
        lrlk    AR0,ASCII_Time
        lack    '-'
        sacl    *+              ;0
        sacl    *+              ;1
        lack    ':'
        sacl    *+              ;2
        lack    '-'
        sacl    *+              ;3
        sacl    *+              ;4
        lack    ':'
        sacl    *+              ;5
        lack    '-'
        sacl    *+              ;6
        sacl    *+              ;7
        lack    ' '
        sacl    *+              ;8      SPACE
        sacl    *+              ;9      place for A or P
        sacl    *+              ;10     place for M
        lack    CR
        sacl    *+              ;11    CR
        lack    LF
        sacl    *               ;12    LF
        ret
;..............................................................................
;==============================================================================
;     ===========     S e r v i c e _ T I C u a r t ( )       ==============
;==============================================================================
;void Service_TICuart(void)
;{
;   if( UART_TX == EMPTY){
;   {
;   if( UART_RX == EMPTY ){
;      if( UART_BYTE == 'R' || UART_BYTE == 'r' )
;        RESET();
;   }
;}
;==============================================================================
Service_TICuart:
        lalk    UART_SEL_LSR    ;select line status register
        sacl    Temp0
        out     Temp0,UART_CTRL
        in      Temp1,UART_READ ;read line status register
        lack    UART_LSR_THRE
        and     Temp1           ;check  xmit holding register full bit
        bz      Stu_1           ;br if UART Transmit buffer not EMPTY
                                ;here if ready to send another UART byte
Stu_1: 
        lack    UART_LSR_RBF
        and     Temp1
        bz      Stu_2           ;br if UART receive buffer empty
        lalk    UART_SEL_RX
        sacl    Temp0
        out     Temp0,UART_CTRL
        in      Temp0,UART_READ ;Temp0 = latest byte from UART
        lac     Temp0           ;just get lower byte
        andk    05Fh
        subk    'R'             ;br if reset command received
        bz      RESET
Stu_2:
        ret

;==============================================================================
;     ================     C a l c _ H r ( )       ==============
;==============================================================================
;void Calc_Hr(void){
;   Local_hr = Hr_count + Local_offset + 12;
;   if( Flags.DAY_SAVINGS && Local_offset != 0 )
;      Local_hr++;
;   Local_hr = HOUR12_TBL[ Local_hr ];
;   if( Local_hr & BIT15 && H24 )
;      ASCII_Time[9] = 'P';
;   else
;      ASCII_Time[9] = 'A';
;   Temp0 = Local_hr & 0x000F;
;   if( H24 ){
;      Temp0 = Hr_count + Local_offset + 12;
;      if( Flags.DAY_SAVINGS && Local_offset != 0 )
;         Temp0++;
;      Temp0 = HOUR24_TBL[ Temp0 ];
;   }
;   itoa( Temp0, ASCII_Time );
;}
;----------------------------------------------------------------------------
Calc_Hr:
        larp    AR0
        lac     Local_offset            ;Local_hr = Hr_count + Local_offset + 12;
        bz      Ch_1                    ;br if GMT 
        bit     Flags,T_DAY_SAVINGS     ;if( Flags.DAY_SAVINGS )
        bbz     Ch_1                    ;   Local_hr++;
        addk    1
Ch_1:
        add     Hr_count
        addk    12
        sacl    Local_hr
        adlk    HOUR12_TBL        ;Local_hr = HOUR_TBL[ Local_hr ];
        tblr    Local_hr
#ifdef H24
        b       Ch_4            ;don't display AM,PM if 24 hour time
#endif
        lrlk    AR0,ASCII_Time+9
        bit     Local_hr,15
        bbz     Ch_2
        lack    'P'
        b       Ch_3
Ch_2:
        lack    'A'
Ch_3:
        sacl    *+
        lack    'M'
        sacl    *
;
Ch_4:
        lac     Local_hr
        andk    000Fh
        sacl    Local_hr        ;use for 12 hr time and gongs
#ifdef H24
        lac     Local_offset    ;Temp0 = Hr_count + Local_offset + 12;
        bz      Ch_5            ;br if GMT
        bit     Flags,T_DAY_SAVINGS ;if( Flags.DAY_SAVINGS )
        bbz     Ch_5                ;   Local_ofset++;
        addk    1
Ch_5:
        add     Hr_count
        addk    12
        sacl    Temp0
        adlk    HOUR24_TBL      ;Temp0 = HOUR24_TBL[ Local_hr ];
        tblr    Temp0
        lac     Temp0           ;use for 24 hr local time
#endif
        lrlk    AR0,ASCII_Time+0
        sacl    Temp0
        call    itoa
        ret
;==============================================================================
;     ================     C a l c _ M i n ( )       ==============
;==============================================================================
;void Calc_Min(void){
;   Temp0 = Min_count;
;   itoa( Temp0, ASCII_Time+3 );
;}
;----------------------------------------------------------------------------
Calc_Min:
        larp    AR0
        lrlk    AR0,ASCII_Time+3
        lac     Min_count
        sacl    Temp0
        call    itoa
        ret
;==============================================================================
;     ================     C a l c _ S e c ( )       ==============
;==============================================================================
;void Calc_Sec(void){
;   Temp0 = Sec_count;
;   itoa( Temp0, ASCII_Time+3 );
;}
;----------------------------------------------------------------------------
Calc_Sec:
        larp    AR0
        lrlk    AR0,ASCII_Time+6
        lac     Sec_count
        sacl    Temp0
        call    itoa
        ret

;==============================================================================
;     ================     C a l c _ s t a t u s ( )       ==============
;==============================================================================
;void Calc_status(void){
;   itoa( Min_status, ASCII_Status+0 );   //put min unit level in status string
;   itoa( M10_Array[4], ASCII_Status+3 ); //put min 10's level in status string
;   itoa( Hr_Array[7], ASCII_Status+6 );  //put hour level in status string
;   itoa( Lock_timer, ASCII_Status+9 );   //put Lock_timer in status string
;}
;----------------------------------------------------------------------------
Calc_status:
        larp    AR0
        lac     Min_status
        sacl    Temp0
        lrlk    AR0,ASCII_Status
        call    itoa
;
        lrlk    AR0,Min10_Array+4
        lac     *
        sacl    Temp0
        lrlk    AR0,ASCII_Status+3
        call    itoa
;
        lrlk    AR0,Hr_Array+7
        lac     *
        sacl    Temp0
        lrlk    AR0,ASCII_Status+6
        call    itoa
;
        lac     Lock_timer
        sacl    Temp0
        lrlk    AR0,ASCII_Status+9
        call    itoa
        ret

;==============================================================================
;     ==============     X m i t _ t i m e ( )       ==============
;     ==============     X m i t _ s t a t u s ( )   ==============
;==============================================================================
;       This routine sends an ASCII string of the current time or status.
Xmit_status:
        lrlk    AR0,ASCII_Status
        b       Xt_1
Xmit_time:
        lrlk    AR0,ASCII_Time
Xt_1:
        larp    AR0
        lac     *+                      ;0
        sacl    Temp1
        subk    '0'                     ;lead zero suppression
        bnz     Xt_2
        lack    ' '
        sacl    Temp1
Xt_2:
        call    Send_To_UART
        lac     *+                      ;1
        sacl    Temp1
        call    Send_To_UART
        lac     *+                      ;2
        sacl    Temp1
        call    Send_To_UART
        lac     *+                      ;3
        sacl    Temp1
        call    Send_To_UART
        lac     *+                      ;4
        sacl    Temp1
        call    Send_To_UART
        lac     *+                      ;5
        sacl    Temp1
        call    Send_To_UART
        lac     *+                      ;6
        sacl    Temp1
        call    Send_To_UART
        lac     *+                      ;7
        sacl    Temp1
        call    Send_To_UART
        lac     *+                      ;8
        sacl    Temp1
        call    Send_To_UART
        lac     *+                      ;9
        sacl    Temp1
        call    Send_To_UART
        lac     *+                      ;10
        sacl    Temp1
        call    Send_To_UART
        lac     *+                      ;11
        sacl    Temp1
        call    Send_To_UART
        lac     *                       ;12
        sacl    Temp1
        call    Send_To_UART
        ret
;-----------------------------------------------------------------------------
;==============================================================================
;     ===================     i t o a ( )       =======================
;==============================================================================
;       This routine converts an integer Temp0(0-99) into a two digit ascii
; string and puts it in ASCII_Array[ AR0 ].
;void itoa( Temp0, AR0 ){
;   Temp0 = abs(Temp0);
;   if( Temp0 >= 100 ){
;      *AR0++ = '9';
;      *AR0 = '9';
;   }else{
;      Temp1 = 0;
;      while( Temp0 < 10 ){
;         Temp1++;                 // inc tens digit
;         Temp0 -= 10;
;      }
;      *AR0++ = Temp1 + '0';
;      *AR0 = Temp0 + '0';
;   }
;}
;..............................................................................
itoa:   larp    AR0
        lac     Temp0
        abs
        sacl    Temp0
        subk    100
        blz     ito_1        
        lack    '9'
        sacl    *+
        sacl    *
        ret
ito_1:  zac
        sacl    Temp1
ito_2:  lac     Temp0
        subk    10
        blz     ito_3        
        sacl    Temp0
        INC(Temp1)
        b       ito_2
ito_3:  lac     Temp1
        addk    '0'
        sacl    *+
        lac     Temp0
        addk    '0'
        sacl    *
        ret
;-----------------------------------------------------------------------------
;==============================================================================
;     ========     S e n d _ T o _ U A R T ( )       ==========
;==============================================================================
;       This routine sends a byte in Temp1 out the DSP-93 interface UART.
;
Send_To_UART:
        lalk    UART_SEL_RX     ;select transmit holding register
        sacl    Temp0
        out     Temp0,UART_CTRL
        out     Temp1,UART_WRITE
        ret
;-----------------------------------------------------------------------------
;==============================================================================
;     ================     S e t _ D T R  ( )       ================
;==============================================================================
;       This routine sets the DTR line high and RTS Low on the UART.
;
Set_DTR:
        lalk    UART_SEL_MCR    ;select modem control register
        sacl    Temp0
        out     Temp0,UART_CTRL
	lack    UART_MCR_DTR
        sacl    Temp0
        out     Temp0,UART_WRITE
        ret
;-----------------------------------------------------------------------------
;==============================================================================
;     =================     C l r _ D T R ( )       ==============
;==============================================================================
;       This routine clears the DTR line and sets the RTS line on the UART.
;
Clr_DTR:
        lalk    UART_SEL_MCR    ;select modem control register
        sacl    Temp0
        out     Temp0,UART_CTRL
	lack    UART_MCR_RTS
        sacl    Temp0
        out     Temp0,UART_WRITE
        ret
;-----------------------------------------------------------------------------
;                TEST output stuff
Send_test:
        ret
        lac     Temp2
        sfr
        sfr
        sfr
        sfr
        sfr
        sfr
        sfr
        sfr
        sacl    Temp1
        call    Send_To_UART
        lac     Temp2
        andk    00FFh
        sacl    Temp1
        call    Send_To_UART
        ret
;
;==============================================================================
;          ========= E N D   o f   T I C U A R T . A S M  ==========
;==============================================================================
